# ================================================================

use strict;

# ================================================================

sub collectURL
{
	my($aTargetURL,$aReferer,$aRootURL,$aMaxDepth,$aDepth,$aDocumentURLList,$aInlineURLList)=@_;

	&updateEntryToDocumentURLList($aDocumentURLList,$aTargetURL,$main::iQuery_is_crawled,1);
	# URL򥯥Ѥߤȥޡ

	if($main::iSkipCrawlOtherDomainURL&&(&isDifferent(&getDomainFromURL($aTargetURL),&getDomainFromURL($aRootURL))))
	# ̥ɥᥤURLؤΥǡ¾ɥᥤؤΥ뤬ػߤƤ
	{
		if(!(&hasStarted($aTargetURL,\@main::iWhiteListURLPrefix)))
		# ۥ磻ȥꥹȤ˴ޤޤʤURLؤΥξ
		{
			print 'Skip(OtherDomainURL) '.$aTargetURL."\n";

			return 0;
		}
	}

	if(&hasStarted($aTargetURL,\@main::iBlackListURLPrefix))
	# ֥åꥹȤ˴ޤޤURLؤΥξ
	{
		print 'Skip(URLInBlackList) '.$aTargetURL."\n";

		return 0;
	}

	# --------  UserAgentѰդ

	use LWP::UserAgent;

	my($tBrowser)=LWP::UserAgent->new();
	$tBrowser->agent($main::iUserAgent);

	# --------  оURLHEAD

	use HTTP::Request;

	my($tRequest1)=HTTP::Request->new('HEAD',$aTargetURL);
	$tRequest1->referer($aReferer);
	my($tResponse1)=$tBrowser->request($tRequest1);

	my($tResponseURL)=$tResponse1->request()->uri()->canonical();
	# ºݤ˥ꥯȤURL

	if(&isDifferent($aTargetURL,$tResponseURL))
	# 쥯ȤƤ
	{
		print 'Skip(Redirected) '.$aTargetURL."\n";

		&addEntryToDocumentURLList($aDocumentURLList,$tResponseURL,$aTargetURL,$aRootURL,$aMaxDepth,$aDepth,'');
		# 쥯URLɥURLꥹȤɲä
	}
	else
	# 쥯ȤƤʤ
	{
	my($tContentType)=$tResponse1->header('Content-Type');
	# Content-Type

	&updateEntryToDocumentURLList($aDocumentURLList,$aTargetURL,$main::iQuery_content_type,$tContentType);
	# URL˼Content-Typeɳդ

		if(!(&isStarted($tContentType,'text/html')))
		# HTTP/HTTPS쥹ݥ󥹤test/htmlǤʤ
		{
			print 'Skip(NoHTMLDocument)'.$aTargetURL.' ('.$tContentType.')'."\n";
		}
		else
		# HTTP/HTTPS쥹ݥ󥹤test/htmlξ
		{
			print 'Crawl '.$aTargetURL.' (depth='.($aDepth+0).')'."\n";

			# --------  оURLGET

			my($tRequest2)=HTTP::Request->new('GET',$aTargetURL);
			$tRequest2->referer($aReferer);
			my($tResponse2)=$tBrowser->request($tRequest2);

			# --------  bodyѡ

			use HTML::LinkExtor;

			my($tParse)=HTML::LinkExtor->new();
			$tParse->parse($tResponse2->{_content});

			my(%tInlineURLList)=();
			# ФURLγǼѰդ

			use URI;

			for my $tLink ($tParse->links)
			# Ф󥯤򣱤ĤĸƤ
			{
				my($tTag,%tAttribute)=@$tLink;
				# °

				if((&isSame(&toLowerCase($tTag),'frame'))||(&isSame(&toLowerCase($tTag),'iframe')))
				# Ф󥯤ΥframeפޤϡiframeץΤΤǤä
				{
					my($tInlineURL)=&removeReference(URI->new_abs($tAttribute{'src'},$aTargetURL)->canonical());
					# URLХѥ˽

					if(&isStarted($tInlineURL,'http://')||&isStarted($tInlineURL,'https://'))
					# URLhttp://פޤϡhttps://פϤޤ
					{
						$tInlineURLList{$tInlineURL}=0;
						# URL򥤥饤URLɲä
					}
				}
				elsif(&isSame(&toLowerCase($tTag),'a'))
				# Ф󥯤ΥaץΤΤǤä
				{
					my($tInlineURL)=&removeReference(URI->new_abs($tAttribute{'href'},$aTargetURL)->canonical());
					# URLХѥ˽

					if(&isStarted($tInlineURL,'http://')||&isStarted($tInlineURL,'https://'))
					# URLhttp://פޤϡhttps://פϤޤ
					{
						$tInlineURLList{$tInlineURL}=1;
						# URL򥤥饤URLɲä
					}
				}
				elsif((&isSame(&toLowerCase($tTag),'img'))||(&isSame(&toLowerCase($tTag),'video'))||(&isSame(&toLowerCase($tTag),'source')))
				# Ф󥯤ΥimgסvideoסsourceץΤΤǤä
				{
					my($tInlineURL)=&removeReference(URI->new_abs($tAttribute{'src'},$aTargetURL)->canonical());
					# URLХѥ˽

					if(&isStarted($tInlineURL,'http://')||&isStarted($tInlineURL,'https://'))
					# URLhttp://פޤϡhttps://פϤޤ
					{
						&addEntryToInlineURLList($aInlineURLList,$tInlineURL,$aTargetURL,$aRootURL);
						# URL򥤥᡼URLɲä
					}
				}
				elsif(&isSame(&toLowerCase($tTag),'script'))
				# Ф󥯤ΥscriptץΤΤǤä
				{
					my($tInlineURL)=&removeReference(URI->new_abs($tAttribute{'src'},$aTargetURL)->canonical());
					# URLХѥ˽

					if(&isStarted($tInlineURL,'http://')||&isStarted($tInlineURL,'https://'))
					# URLhttp://פޤϡhttps://פϤޤ
					{
						$tInlineURL=&handleScriptURL($tInlineURL);
						# script URL

						if(&isDifferent($tInlineURL,''))
						# 줿URLǤʤȤ
						{
							&addEntryToInlineURLList($aInlineURLList,$tInlineURL,$aTargetURL,$aRootURL);
							# URL򥤥᡼URLɲä
						}
					}
				}
			}

			foreach(sort keys %tInlineURLList)
			# 饤URLURLˤʤ
			{
				my($tInlineURL)=$_;
				my($tInlineOffset)=$tInlineURLList{$tInlineURL};

				if(&isDifferent($tInlineURL,$aReferer))
				# URLܸURLȰ㤦Ȥ
				{
					if(!$$aDocumentURLList{$tInlineURL})
					# Ф饤URLɥURLꥹȤˤʤ
					{
						&addEntryToDocumentURLList($aDocumentURLList,$tInlineURL,$aTargetURL,$aRootURL,$aMaxDepth,($aDepth+$tInlineOffset),'');
						# Υ饤URLɥURLꥹȤɲä
					}
					else
					# Ф饤URLɥURLꥹȤˤ
					{
						my($tInlineURLDepth)=($aDepth+$tInlineOffset);
						# 饤URLο٤׻

						if($$aDocumentURLList{$aTargetURL}{$main::iQuery_depth}>$tInlineURLDepth)
						# Υõ٤äʤƻĤä
						{
							print 'Update(ShorterRouteFound) '.$aTargetURL.'(depth='.($$aDocumentURLList{$aTargetURL}{$main::iQuery_depth}+0).'->'.$tInlineURLDepth.')'."\n";

							# --------  ɥURLꥹȤˤ뤳Υ饤URLξ򹹿

							&updateEntryToDocumentURLList($aDocumentURLList,$tInlineURL,$main::iQuery_referer,$aTargetURL);
							&updateEntryToDocumentURLList($aDocumentURLList,$tInlineURL,$main::iQuery_depth,$tInlineURLDepth);
							&updateEntryToDocumentURLList($aDocumentURLList,$tInlineURL,$main::iQuery_force_reroute,1);
						}
					}
				}
			}

			&updateEntryToDocumentURLList($aDocumentURLList,$aTargetURL,$main::iQuery_url_list,\%tInlineURLList);
			# URLФURLɳդ
		}
	}

	return 1;
}

# ----------------------------------------------------------------

sub addEntryToDocumentURLList
{
	my($aURLList,$aTargetURL,$aReferer,$aRootURL,$aMaxDepth,$aDepth,$aContentType)=@_;

	if(!$$aURLList{$aTargetURL})
	# оݤURLɥURLꥹȤ¸ߤʤ
	{
		$$aURLList{$aTargetURL}{$main::iQuery_referer}=$aReferer;
		$$aURLList{$aTargetURL}{$main::iQuery_root}=$aRootURL;
		$$aURLList{$aTargetURL}{$main::iQuery_max_depth}=$aMaxDepth;
		$$aURLList{$aTargetURL}{$main::iQuery_depth}=$aDepth;
		$$aURLList{$aTargetURL}{$main::iQuery_content_type}=$aContentType;
		$$aURLList{$aTargetURL}{$main::iQuery_is_crawled}=0;
		$$aURLList{$aTargetURL}{$main::iQuery_force_reroute}=0;
		$$aURLList{$aTargetURL}{$main::iQuery_url_list}=();
	}
}

# ----------------------------------------------------------------

sub updateEntryToDocumentURLList
{
	my($aURLList,$aTargetURL,$aKey,$aValue)=@_;

	if($$aURLList{$aTargetURL})
	# оݤURLɥURLꥹȤ¸ߤ
	{
		$$aURLList{$aTargetURL}{$aKey}=$aValue;
	}
}

# ----------------------------------------------------------------

sub addEntryToInlineURLList
{
	my($aURLList,$aTargetURL,$aReferer,$aRootURL)=@_;

	if(!$$aURLList{$aTargetURL})
	# оݤURL᡼URLꥹȤ¸ߤʤ
	{
		$$aURLList{$aTargetURL}{$main::iQuery_referer}=$aReferer;
		$$aURLList{$aTargetURL}{$main::iQuery_root}=$aRootURL;
	}
}

# ----------------------------------------------------------------

sub getNumberOfCrawledURL
{
	my($aURLList)=@_;

	my($tResult)=0;

	foreach(sort keys %$aURLList)
	{
		my($tURL)=$_;
		my($tIsCrawled)=$$aURLList{$tURL}{$main::iQuery_is_crawled};

		if($tIsCrawled)
		{
			$tResult++;
		}
	}

	return $tResult;
}

# ----------------------------------------------------------------

sub saveDocumentURLList
{
	my($aFileName,$aURLList)=@_;

	open(DATA_FILE,'>'.$aFileName);
	flock(DATA_FILE,2);

	my($tResult)=0;

	foreach(sort keys %$aURLList)
	{
		my($tURL)=$_;
		my($tReferer)=$$aURLList{$tURL}{$main::iQuery_referer};
		my($tRootURL)=$$aURLList{$tURL}{$main::iQuery_root};
		my($tDepth)=$$aURLList{$tURL}{$main::iQuery_depth};
		my($tContentType)=$$aURLList{$tURL}{$main::iQuery_content_type};
		my($tIsCrawled)=$$aURLList{$tURL}{$main::iQuery_is_crawled};

		print DATA_FILE '"'.$tURL.'","'.$tReferer.'","'.$tRootURL.'","'.$tDepth.'","'.$tContentType.'","'.$tIsCrawled.'"'."\n";

		$tResult++;
	}

	close(DATA_FILE);

	return $tResult;
}

# ----------------------------------------------------------------

sub saveInlineURLList
{
	my($aFileName,$aURLList)=@_;

	open(DATA_FILE,'>'.$aFileName);
	flock(DATA_FILE,2);

	my($tResult)=0;

	foreach(sort keys %$aURLList)
	{
		my($tURL)=$_;
		my($tReferer)=$$aURLList{$tURL}{$main::iQuery_referer};
		my($tRootURL)=$$aURLList{$tURL}{$main::iQuery_root};

		print DATA_FILE '"'.$tURL.'","'.$tReferer.'","'.$tRootURL.'"'."\n";

		$tResult++;
	}

	close(DATA_FILE);

	return $tResult;
}

# ----------------------------------------------------------------

sub filterURLList
{
	my($aInputFileName,$aOutputFileName,$aExtensionList)=@_;

	open(FILE_INPUT,'<'.$aInputFileName);
	flock(FILE_INPUT,1);

	open(FILE_OUTPUT,'>'.$aOutputFileName);
	flock(FILE_OUTPUT,2);

	my($tFilteredURLCount)=0;

	while(my $tLine=<FILE_INPUT>)
	{
		$tLine.=<FILE_INPUT> while($tLine=~tr/"//%2 and !eof(FILE_INPUT));

		my($tLineOriginal)=$tLine;

		$tLine=~s/(?:\x0D\x0A|[\x0D\x0A])?$/,/;
		my(@tValue)=map{/^"(.*)"$/s?scalar($_=$1,s/""/"/g,$_):$_}($tLine=~/("[^"]*(?:""[^"]*)*"|[^,]*),/g);

		if(&hasSame(&getExtensionUnix(&removeQuery($tValue[0])),$aExtensionList))
		{
			print FILE_OUTPUT $tLineOriginal;
			$tFilteredURLCount++;
		}
	}

	close(FILE_INPUT);
	close(FILE_OUTPUT);

	return $tFilteredURLCount
}

# ----------------------------------------------------------------

sub loadAlreadyDownloadedFileList
{
	my($aFileName)=@_;

	my(%tResult)=();

	open(DATA_FILE,'<'.$aFileName);
	flock(DATA_FILE,1);

	while(my $tLine=<DATA_FILE>)
	{
		$tLine.=<DATA_FILE> while($tLine=~tr/"//%2 and !eof(DATA_FILE));
		$tLine=~s/(?:\x0D\x0A|[\x0D\x0A])?$/,/;
		my(@tValue)=map{/^"(.*)"$/s?scalar($_=$1,s/""/"/g,$_):$_}($tLine=~/("[^"]*(?:""[^"]*)*"|[^,]*),/g);

		$tResult{$tValue[0]}{$main::iQuery_referer}=$tValue[1];
		$tResult{$tValue[0]}{$main::iQuery_root}=$tValue[2];
		$tResult{$tValue[0]}{$main::iQuery_date}=$tValue[3];
	}

	close(DATA_FILE);

	return %tResult;
}

# ----------------------------------------------------------------

sub saveAlreadyDownloadedFileList
{
	my($aFileName,$aListAlreadyDownloaded)=@_;

	open(DATA_FILE,'>'.$aFileName);
	flock(DATA_FILE,2);

	foreach(sort keys %$aListAlreadyDownloaded)
	{
		my($tURL)=$_;
		my($tReferer)=$$aListAlreadyDownloaded{$tURL}{$main::iQuery_referer};
		my($tRoot)=$$aListAlreadyDownloaded{$tURL}{$main::iQuery_root};
		my($tDate)=$$aListAlreadyDownloaded{$tURL}{$main::iQuery_date};

		print DATA_FILE '"'.$tURL.'","'.$tReferer.'","'.$tRoot.'","'.$tDate.'"'."\n";
	}

	close(DATA_FILE);
}

# ----------------------------------------------------------------

sub downloadFileFromURLList
{
	my($aFileName,$aListAlreadyDownloaded,$aNewListAlreadyDownloaded,$aTotalDownloadSizeRemaining)=@_;

	open(DATA_FILE,'<'.$aFileName);
	flock(DATA_FILE,1);

	my(@tURLList)=();
	my(@tRefererList)=();
	my(@tRootURLList)=();

	my($tListLength)=0;

	my($tTotalDownloadSizeRemaining)=$aTotalDownloadSizeRemaining;

	while(my $tLine=<DATA_FILE>)
	{
		$tLine.=<DATA_FILE> while($tLine=~tr/"//%2 and !eof(DATA_FILE));
		$tLine=~s/(?:\x0D\x0A|[\x0D\x0A])?$/,/;
		my(@tValue)=map{/^"(.*)"$/s?scalar($_=$1,s/""/"/g,$_):$_}($tLine=~/("[^"]*(?:""[^"]*)*"|[^,]*),/g);

		$tURLList[$tListLength]=$tValue[0];
		$tRefererList[$tListLength]=$tValue[1];
		$tRootURLList[$tListLength]=$tValue[2];

		$tListLength++;
	}

	close(DATA_FILE);

	my($tCurrentCount)=0;
	my($tIsDownloaded)=0;

	while($tCurrentCount<$tListLength)
	{
		my(%tDomainList)=();

		if($tIsDownloaded)
		{
			if($main::iDownloadDuration>0)
			{
				print 'Wait '.$main::iDownloadDuration.' sec'."\n";

				sleep($main::iDownloadDuration);
			}

			$tIsDownloaded=0;
		}

		for(my($tCount1)=0;$tCount1<$tListLength;$tCount1++)
		{
			my($tURL)=$tURLList[$tCount1];
			my($tReferer)=$tRefererList[$tCount1];
			my($tRootURL)=$tRootURLList[$tCount1];

			if(&isDifferent($tURL,''))
			{
				if($tTotalDownloadSizeRemaining>0)
				{
					if($$aListAlreadyDownloaded{$tURL})
					{
						print 'Skip(URLAlreadyDownloaded) '.$tURL."\n";

						$tURLList[$tCount1]='';
						$tCurrentCount++;

						$$aNewListAlreadyDownloaded{$tURL}{$main::iQuery_referer}=$$aListAlreadyDownloaded{$tURL}{$main::iQuery_referer};
						$$aNewListAlreadyDownloaded{$tURL}{$main::iQuery_root}=$$aListAlreadyDownloaded{$tURL}{$main::iQuery_root};
						$$aNewListAlreadyDownloaded{$tURL}{$main::iQuery_date}=$$aListAlreadyDownloaded{$tURL}{$main::iQuery_date};
					}
					else
					{
						my($tDomain)=&getDomainFromURL($tURL);

						if($tDomainList{$tDomain}!=1)
						{
							$tURLList[$tCount1]='';
							$tCurrentCount++;

							$tDomainList{$tDomain}=1;
							$tIsDownloaded=1;

							my($tTargetURL)=$tURL;

							$tTargetURL=~ s/\%0A//g;

							my($tDirectory)=$main::iFileDirectory.&getDirectoryFromPathUnix(&removeQuery(&removeReference(&removeScheme($tTargetURL))));

							&makeDirectory($tDirectory);

							my($tFileDownloaded)=&downloadFile($tTargetURL,$tReferer,$tDirectory,$main::iUserAgent);

							print 'Download '.$tURL."\n";

							$tTotalDownloadSizeRemaining-=&getFileSize($tFileDownloaded);

							$$aNewListAlreadyDownloaded{$tURL}{$main::iQuery_referer}=$tReferer;
							$$aNewListAlreadyDownloaded{$tURL}{$main::iQuery_root}=$tRootURL;
							$$aNewListAlreadyDownloaded{$tURL}{$main::iQuery_date}=&getCurrentTimeString(9);
						}
					}
				}
				else
				{
					$tURLList[$tCount1]='';
					$tCurrentCount++;

					print 'Skip(TotalDownloadLimitAchieved) '.$tURL."\n";
				}
			}
		}
	}

	return $tTotalDownloadSizeRemaining;
}

# ----------------------------------------------------------------

sub handleScriptURL
{
	my($aURL)=@_;

	my($tURL)=$aURL;

	my($tURLWithoutQuery)=&removeQuery($aURL);

	if(&isContained($tURLWithoutQuery,'/setAffplayer.js'))
	{
		my(%tQuery)=&getQueryEntries($tURL,0);

		$tURL=$tQuery{'video'};
	}
	else
	{
		$tURL='';
	}

	return $tURL;
}

# ================================================================

1;
