#!/bin/sh

source="${1}"
destination="${2}"

if [ -z "${source}" ]
then
	echo '[ALERT] Source is not specified, operation aborted.' 1>&2
	exit
fi

if [ ! -f "${source}" ]
then
	echo '[ALERT] Source is not found, operation aborted.' 1>&2
	exit
fi

if [ -z "${destination}" ]
then
	echo '[ALERT] Destination is not specified, operation aborted.' 1>&2
	exit
fi

if [ ! -d "${destination}" ]
then
	echo '[ALERT] Destination is not a directory, operation aborted.' 1>&2
	exit
fi

count=1

while :
do
        prefix=$(printf "%04d" "${count}")

	filename="${prefix}_${Source##*/}"

	if [ ! -f "${destination}${filename}" ]
	then
		break;
	fi

	count=$(($count+1))
done

mv "${Source}" "${destination}${filename}"

