#!/bin/sh

source="${1}"
destination="${2}"
prefix="${3}"

if [ -z "${source}" ]
then
	echo '[ALERT] Source is not specified, operation aborted.' 1>&2
	exit
fi

if [ ! -f "${source}" ]
then
	echo '[ALERT] Source is not found, operation aborted.' 1>&2
	exit
fi

if [ -z "${destination}" ]
then
	echo '[ALERT] Destination is not specified, operation aborted.' 1>&2
	exit
fi

if [ ! -d "${destination}" ]
then
	echo '[ALERT] Destination is not found, operation aborted.' 1>&2
	exit
fi

if [ -z "${prefix}" ]
then
	echo '[ALERT] Prefix is not specified, operation aborted.' 1>&2
	exit
fi

filename="`echo "${source}" | sed -e s"#${prefix}##g" | sed -e s'#\.\./##g' | sed -e s'#\./##g' | sed -e s'#/#_#g'`"

mv "${source}" "${destination}${filename}"

